import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import { useMount } from '@s-ui/react-hooks';
import Notification from '@s-ui/react-molecule-notification';
import { CLASS, I18N } from '../settings';
export default function CmpBanner(_ref) {
  var lang = _ref.lang,
      onAccept = _ref.onAccept,
      onConfigure = _ref.onConfigure;
  var textRef = useRef();
  useMount(function () {
    var textDOM = textRef.current;
    var openCookiesDOM = textDOM.querySelector("." + CLASS + "-link");
    openCookiesDOM.addEventListener('click', _handleOpenCookies);
    return function () {
      return openCookiesDOM && openCookiesDOM.removeEventListener('click', _handleOpenCookies);
    };
  });

  var _generateButtons = function _generateButtons(_ref2) {
    var lang = _ref2.lang;
    var i18n = I18N[lang];
    return [{
      children: i18n.ACCEPT_BUTTON,
      negative: true,
      onClick: onAccept,
      size: 'small',
      type: 'primary'
    }];
  };

  var _handleOpenCookies = function _handleOpenCookies(e) {
    e.preventDefault();
    onConfigure();
  };

  return /*#__PURE__*/_jsx("div", {
    className: CLASS,
    children: /*#__PURE__*/_jsx(Notification, {
      autoClose: "manual",
      buttons: _generateButtons({
        lang: lang
      }),
      position: "bottom",
      show: true,
      showCloseButton: false,
      variation: "positive",
      type: "system",
      children: /*#__PURE__*/_jsx("span", {
        className: CLASS + "-text",
        ref: textRef,
        dangerouslySetInnerHTML: {
          __html: I18N[lang].BANNER_BODY
        }
      })
    })
  });
}